"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoreModel = void 0;
var firestore_1 = __importStar(require("@react-native-firebase/firestore"));
var StoreModel = (function () {
    function StoreModel(table, firestoreDB) {
        this._firestoreDB = firestoreDB;
        this._table = this._firestoreDB.collection(table);
    }
    StoreModel.prototype.find = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var docSnap, _1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this._table.doc(id).get()];
                    case 1:
                        docSnap = _a.sent();
                        if (docSnap.exists) {
                            return [2, {
                                    data: __assign(__assign({}, docSnap.data()), { reference: id }),
                                    message: "Document found",
                                    status: 'success'
                                }];
                        }
                        return [2, { message: 'Document does not exist', status: 'success' }];
                    case 2:
                        _1 = _a.sent();
                        return [2, { message: 'Document does not exist', status: 'error' }];
                    case 3: return [2];
                }
            });
        });
    };
    StoreModel.prototype.findAll = function (ids) {
        return __awaiter(this, void 0, void 0, function () {
            var results, _i, ids_1, id, item, snapshots, data, _2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 8, , 9]);
                        if (!ids) return [3, 5];
                        results = [];
                        _i = 0, ids_1 = ids;
                        _a.label = 1;
                    case 1:
                        if (!(_i < ids_1.length)) return [3, 4];
                        id = ids_1[_i];
                        return [4, this.find(id)];
                    case 2:
                        item = _a.sent();
                        if (item.data) {
                            results.push(item);
                        }
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3, 1];
                    case 4: return [2, { data: results, message: 'Documents found', status: 'success' }];
                    case 5: return [4, this._table.get()];
                    case 6:
                        snapshots = _a.sent();
                        if (!snapshots.empty) {
                            data = snapshots.docs.map(function (document) {
                                return __assign(__assign({}, document.data()), { reference: document.id });
                            });
                            return [2, { data: data, message: 'Documents found', status: 'success' }];
                        }
                        else {
                            return [2, { message: 'Documents empty', status: 'success' }];
                        }
                        _a.label = 7;
                    case 7: return [3, 9];
                    case 8:
                        _2 = _a.sent();
                        return [2, { message: 'Document does not exist', status: 'error' }];
                    case 9: return [2];
                }
            });
        });
    };
    StoreModel.prototype.findWhereOrAnd = function (_a) {
        return __awaiter(this, arguments, void 0, function (_b) {
            var andWhere_1, orWhere_1, queryRef, off, snapshot, data, _3;
            var wh = _b.wh, lim = _b.lim, order = _b.order, offset = _b.offset;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _c.trys.push([0, 4, , 5]);
                        andWhere_1 = [];
                        orWhere_1 = [];
                        queryRef = this._table;
                        if (wh) {
                            wh.parameter.forEach(function (clause) {
                                var key = clause.key, operator = clause.operator, value = clause.value;
                                var whe = (0, firestore_1.Filter)(key, operator, value);
                                clause.type === 'and' ?
                                    andWhere_1.push(whe) : orWhere_1.push(whe);
                            });
                            if (wh.type === 'andOr') {
                                queryRef = this._table.where(firestore_1.Filter.and.apply(firestore_1.Filter, __spreadArray(__spreadArray([], andWhere_1, false), [firestore_1.Filter.or.apply(firestore_1.Filter, orWhere_1)], false)));
                            }
                            else if (wh.type === 'or') {
                                queryRef = firestore_1.Filter.or.apply(firestore_1.Filter, orWhere_1);
                            }
                            else {
                                queryRef = firestore_1.Filter.and.apply(firestore_1.Filter, andWhere_1);
                            }
                        }
                        if (order) {
                            queryRef.orderBy(order);
                        }
                        if (!offset) return [3, 2];
                        return [4, this._table.doc(offset).get()];
                    case 1:
                        off = _c.sent();
                        queryRef.startAfter(off.data());
                        _c.label = 2;
                    case 2:
                        if (lim) {
                            queryRef.limit(lim);
                        }
                        return [4, this._table.get()];
                    case 3:
                        snapshot = _c.sent();
                        if (!snapshot.empty) {
                            data = snapshot.docs.map(function (document) {
                                return __assign(__assign({}, document.data()), { reference: document.id });
                            });
                            return [2, { data: data, message: 'Documents found', status: 'success' }];
                        }
                        else {
                            return [2, { message: 'No Documents found', status: 'success' }];
                        }
                        return [3, 5];
                    case 4:
                        _3 = _c.sent();
                        return [2, { message: 'No Documents found', status: 'error' }];
                    case 5: return [2];
                }
            });
        });
    };
    StoreModel.prototype.findWhere = function (_a) {
        return __awaiter(this, arguments, void 0, function (_b) {
            var andWhere_2, off, snapshot, data, error_1;
            var wh = _b.wh, lim = _b.lim, order = _b.order, offset = _b.offset;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _c.trys.push([0, 4, , 5]);
                        andWhere_2 = [];
                        wh ? wh.forEach(function (clause) {
                            var key = clause.key, operator = clause.operator, value = clause.value;
                            var whe = (0, firestore_1.Filter)(key, operator, value);
                            andWhere_2.push(whe);
                        }) : [];
                        if (wh) {
                            this._table.where(firestore_1.Filter.and.apply(firestore_1.Filter, andWhere_2));
                        }
                        if (order) {
                            this._table.orderBy(order);
                        }
                        if (!offset) return [3, 2];
                        return [4, this._table.doc(offset).get()];
                    case 1:
                        off = _c.sent();
                        this._table.startAfter(off.data());
                        _c.label = 2;
                    case 2:
                        if (lim) {
                            this._table.limit(lim);
                        }
                        return [4, this._table.get()];
                    case 3:
                        snapshot = _c.sent();
                        if (!snapshot.empty) {
                            data = snapshot.docs.map(function (document) {
                                return __assign(__assign({}, document.data()), { reference: document.id });
                            });
                            return [2, { data: data, message: 'Documents found', status: 'success' }];
                        }
                        else {
                            return [2, { message: 'No Documents found', status: 'success' }];
                        }
                        return [3, 5];
                    case 4:
                        error_1 = _c.sent();
                        return [2, { message: 'No Documents found', status: 'error' }];
                    case 5: return [2];
                }
            });
        });
    };
    StoreModel.prototype.save = function (data, id) {
        return __awaiter(this, void 0, void 0, function () {
            var documentRef, _4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        delete data.reference;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 6, , 7]);
                        if (!(id === undefined)) return [3, 3];
                        return [4, this._table.add(data)];
                    case 2:
                        documentRef = _a.sent();
                        return [2, { status: 'success', message: 'Document added successfully!', data: documentRef.id }];
                    case 3: return [4, this._table.doc(id).set(data)];
                    case 4:
                        _a.sent();
                        return [2, { status: 'success', message: 'Document updated successfully!', data: id }];
                    case 5: return [3, 7];
                    case 6:
                        _4 = _a.sent();
                        return [2, { status: 'error', message: 'Unable to save document' }];
                    case 7: return [2];
                }
            });
        });
    };
    StoreModel.prototype.delete = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this._table.doc(id).delete()];
                    case 1:
                        _a.sent();
                        return [2, { status: 'success', message: 'Document deleted successfully!' }];
                    case 2:
                        error_2 = _a.sent();
                        return [2, { status: 'success', message: 'Unable to delete document' }];
                    case 3: return [2];
                }
            });
        });
    };
    StoreModel.prototype.update = function (data, id) {
        return __awaiter(this, void 0, void 0, function () {
            var result, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        delete data.reference;
                        return [4, this._table.doc(id).update(data)];
                    case 1:
                        result = _a.sent();
                        return [2, { data: result, message: 'Data updated successfully', status: 'success' }];
                    case 2:
                        error_3 = _a.sent();
                        return [2, { message: 'Unable to update document', status: 'error' }];
                    case 3: return [2];
                }
            });
        });
    };
    StoreModel.prototype.stream = function (callBack, id) {
        try {
            if (id) {
                this._table.doc(id).onSnapshot(function (doc) {
                    callBack(__assign(__assign({}, doc.data()), { reference: id }));
                });
            }
            else {
                this._table.onSnapshot(function (coll) {
                    callBack(coll.docs.map(function (value) {
                        var data = __assign(__assign({}, value.data()), { reference: value.id });
                        return data;
                    }));
                });
            }
        }
        catch (_) {
            return;
        }
    };
    StoreModel.prototype.streamWhere = function (wh, callBack, lim, order, offset) {
        return __awaiter(this, void 0, void 0, function () {
            var andWhere_3, off, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        andWhere_3 = [];
                        wh ? wh.forEach(function (clause) {
                            var key = clause.key, operator = clause.operator, value = clause.value;
                            var whe = (0, firestore_1.Filter)(key, operator, value);
                            andWhere_3.push(whe);
                        }) : [];
                        if (wh) {
                            this._table.where(firestore_1.Filter.and.apply(firestore_1.Filter, andWhere_3));
                        }
                        if (order) {
                            this._table.orderBy(order);
                        }
                        if (!offset) return [3, 2];
                        return [4, this._table.doc(offset).get()];
                    case 1:
                        off = _a.sent();
                        this._table.startAfter(off.data());
                        _a.label = 2;
                    case 2:
                        if (lim) {
                            this._table.limit(lim);
                        }
                        this._table.onSnapshot(function (snapShot) {
                            callBack(snapShot.docs.map(function (value) {
                                var data = __assign(__assign({}, value.data()), { reference: value.id });
                                return data;
                            }));
                        });
                        return [3, 4];
                    case 3:
                        error_4 = _a.sent();
                        return [2];
                    case 4: return [2];
                }
            });
        });
    };
    StoreModel.prototype.countData = function (where) {
        return __awaiter(this, void 0, void 0, function () {
            var andWhere_4, data, _5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        andWhere_4 = [];
                        where ? where.forEach(function (clause) {
                            var key = clause.key, operator = clause.operator, value = clause.value;
                            var whe = (0, firestore_1.Filter)(key, operator, value);
                            andWhere_4.push(whe);
                        }) : [];
                        this._table.where(firestore_1.Filter.and.apply(firestore_1.Filter, andWhere_4));
                        return [4, this._table.countFromServer().get()];
                    case 1:
                        data = _a.sent();
                        return [2, { message: "Counted data", status: 'success', data: data.data() }];
                    case 2:
                        _5 = _a.sent();
                        return [2, { message: "Unable to cound data", status: "error" }];
                    case 3: return [2];
                }
            });
        });
    };
    StoreModel.prototype.saveBatch = function (_a) {
        var data = _a.data;
        throw new Error("Method not implemented.");
    };
    StoreModel.prototype.updateBatch = function (_a) {
        var data = _a.data;
        throw new Error("Method not implemented.");
    };
    StoreModel.prototype.deleteBatch = function (_a) {
        var ids = _a.ids;
        throw new Error("Method not implemented.");
    };
    StoreModel.prototype.incrementDecrement = function (_a) {
        return __awaiter(this, arguments, void 0, function (_b) {
            var docRef, value, error_5;
            var _c;
            var dbReference = _b.dbReference, key = _b.key, isIncrement = _b.isIncrement, incrementalValue = _b.incrementalValue;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 2, , 3]);
                        docRef = this._table.doc(dbReference);
                        value = isIncrement ? incrementalValue !== null && incrementalValue !== void 0 ? incrementalValue : 1 : (incrementalValue !== null && incrementalValue !== void 0 ? incrementalValue : 1) * -1;
                        return [4, docRef.update((_c = {}, _c[key] = firestore_1.default.FieldValue.increment(value), _c))];
                    case 1:
                        _d.sent();
                        return [2, { status: 'success', message: "Counter successful" }];
                    case 2:
                        error_5 = _d.sent();
                        return [2, { status: 'error', message: "unable to count data" }];
                    case 3: return [2];
                }
            });
        });
    };
    return StoreModel;
}());
exports.StoreModel = StoreModel;
//# sourceMappingURL=StoreModel.js.map