"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserModel = void 0;
var StoreModel_1 = require("./StoreModel");
var auth_1 = require("firebase/auth");
var UserModel = (function (_super) {
    __extends(UserModel, _super);
    function UserModel(auth, firestoreDB, table) {
        var _this = _super.call(this, table !== null && table !== void 0 ? table : "Users", firestoreDB) || this;
        _this._auth = auth;
        return _this;
    }
    UserModel.prototype.registerWithEmailAndPassword = function (_a) {
        return __awaiter(this, arguments, void 0, function (_b) {
            var user, error_1;
            var _c;
            var email = _b.email, password = _b.password, userData = _b.userData;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 2, , 3]);
                        return [4, ((_c = this._auth) === null || _c === void 0 ? void 0 : _c.createUserWithEmailAndPassword(email, password))];
                    case 1:
                        user = _d.sent();
                        if (user && userData) {
                            this.save(userData, user.user.uid);
                        }
                        return [2, {
                                data: user,
                                status: 'success',
                                message: 'User registered successfully'
                            }];
                    case 2:
                        error_1 = _d.sent();
                        if (error_1.code === 'auth/email-already-in-use') {
                            return [2, {
                                    status: 'error',
                                    message: "".concat(email, " is already in use!")
                                }];
                        }
                        if (error_1.code === 'auth/invalid-email') {
                            return [2, {
                                    status: 'error',
                                    message: "".concat(email, " is an invalid email address")
                                }];
                        }
                        return [2, {
                                status: 'error',
                                message: 'Unable to register user'
                            }];
                    case 3: return [2];
                }
            });
        });
    };
    UserModel.prototype.login = function (_a) {
        return __awaiter(this, arguments, void 0, function (_b) {
            var signedIn, error_2;
            var email = _b.email, password = _b.password, _c = _b.verifyEmail, verifyEmail = _c === void 0 ? false : _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 2, , 3]);
                        return [4, this._auth.signInWithEmailAndPassword(email, password)];
                    case 1:
                        signedIn = _d.sent();
                        if (verifyEmail) {
                            if (!signedIn.user.emailVerified) {
                                return [2, {
                                        status: 'error',
                                        message: 'Email address needs verification'
                                    }];
                            }
                        }
                        return [2, {
                                status: 'success',
                                message: 'User logged in successfully',
                                data: signedIn
                            }];
                    case 2:
                        error_2 = _d.sent();
                        return [2, {
                                status: 'error',
                                message: 'Invalid login credentials'
                            }];
                    case 3: return [2];
                }
            });
        });
    };
    UserModel.prototype.logout = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this._auth.signOut()];
                    case 1:
                        _a.sent();
                        return [2, {
                                status: 'success',
                                message: "User signout!"
                            }];
                    case 2:
                        _1 = _a.sent();
                        return [2, { status: 'error', message: 'Unable to complete process' }];
                    case 3: return [2];
                }
            });
        });
    };
    UserModel.prototype.deleteAccount = function (user) {
        return __awaiter(this, void 0, void 0, function () {
            var error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, Promise.all([
                                (0, auth_1.deleteUser)(user),
                                this.delete(user.uid)
                            ])];
                    case 1:
                        _a.sent();
                        return [2, { status: 'success', message: 'Account deleted successfully' }];
                    case 2:
                        error_3 = _a.sent();
                        return [2, { status: 'error', message: "unable to delete user account" }];
                    case 3: return [2];
                }
            });
        });
    };
    return UserModel;
}(StoreModel_1.StoreModel));
exports.UserModel = UserModel;
//# sourceMappingURL=UserModel.js.map