"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.moneyFormatter = exports.convertUnicode = exports.getCurrentLocation = exports.camelToTitleCase = exports.getUrlParams = exports.generateRandomString = void 0;
var generateRandomString = function (length) {
    if (length > 60) {
        throw new Error("Maximum generatable character is 60, ".concat(length, " was required"));
    }
    var result = '';
    var characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
};
exports.generateRandomString = generateRandomString;
var getUrlParams = function () {
    var urlParams = new URLSearchParams(window.location.search);
    return Object.fromEntries(urlParams);
};
exports.getUrlParams = getUrlParams;
var camelToTitleCase = function (key) {
    var topic = key[0].toUpperCase() + key.slice(1);
    var result = '';
    var i = 0;
    while (i < topic.length) {
        if (i === 0) {
            result += topic.charAt(i);
        }
        else {
            if (topic.charAt(i) === topic.charAt(i).toUpperCase()) {
                result += " ".concat(topic.charAt(i));
            }
            else {
                result += topic.charAt(i);
            }
        }
        i++;
    }
    return result;
};
exports.camelToTitleCase = camelToTitleCase;
var getCurrentLocation = function () {
    var currentPath = window.location.pathname;
    var pathArr = currentPath.split('/');
    return pathArr[1];
};
exports.getCurrentLocation = getCurrentLocation;
function convertUnicode(input) {
    return input.replace(/\\+u([0-9a-fA-F]{4})/g, function (a, b) {
        return String.fromCharCode(parseInt(b, 16));
    });
}
exports.convertUnicode = convertUnicode;
var moneyFormatter = function (x, shorten, decimailPlaces) {
    if (shorten === void 0) { shorten = true; }
    if (x === undefined) {
        return "";
    }
    var base = 1000000;
    var num = parseInt(x);
    if (num < base || !shorten) {
        return num.toFixed(decimailPlaces).replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    }
    else {
        var val = '';
        if (num < (base * 1000)) {
            val = (num / base).toFixed(decimailPlaces) + "M";
        }
        else {
            val = (num / (base * 1000)).toFixed(decimailPlaces) + "B";
        }
        return val;
    }
};
exports.moneyFormatter = moneyFormatter;
//# sourceMappingURL=helpers.js.map