import { DocumentData } from "firebase/firestore";
import { StoreInterface } from "./StoreInterface";
import { QueryReturn, andOrWhereClause, whereClause } from "./datatypes";
import { FirebaseFirestoreTypes } from '@react-native-firebase/firestore';
export declare class StoreModel implements StoreInterface {
    protected _table: FirebaseFirestoreTypes.CollectionReference;
    private _firestoreDB;
    constructor(table: string, firestoreDB: FirebaseFirestoreTypes.Module);
    find(id: string): Promise<QueryReturn>;
    findAll(ids?: string[] | undefined): Promise<QueryReturn>;
    findWhereOrAnd({ wh, lim, order, offset }: {
        wh?: {
            type: "or" | "and" | "andOr";
            parameter: andOrWhereClause[];
        } | undefined;
        lim?: number | undefined;
        order?: string | undefined;
        offset?: string | undefined;
    }): Promise<QueryReturn>;
    findWhere({ wh, lim, order, offset }: {
        wh?: whereClause[];
        lim?: number | undefined;
        order?: string | undefined;
        offset?: string | undefined;
    }): Promise<QueryReturn>;
    save(data: object, id?: string): Promise<QueryReturn>;
    delete(id: string): Promise<QueryReturn>;
    update(data: object, id: string): Promise<QueryReturn>;
    stream(callBack: (data: DocumentData | DocumentData[] | undefined) => void, id?: string | undefined): void;
    streamWhere(wh: whereClause[], callBack: (data: DocumentData[]) => void, lim?: number | undefined, order?: string | undefined, offset?: string | undefined): Promise<void>;
    countData(where: whereClause[]): Promise<QueryReturn>;
    saveBatch({ data }: {
        data: object[];
    }): Promise<QueryReturn>;
    updateBatch({ data }: {
        data: object[];
        callBack: () => void;
    }): Promise<QueryReturn>;
    deleteBatch({ ids }: {
        ids: string[];
    }): Promise<QueryReturn>;
    incrementDecrement({ dbReference, key, isIncrement, incrementalValue }: {
        dbReference: string;
        key: string;
        isIncrement?: boolean | undefined;
        incrementalValue?: number | undefined;
    }): Promise<QueryReturn>;
}
