import { AuthInterface } from "./AuthInterface";
import { FirebaseAuthTypes } from '@react-native-firebase/auth';
import { StoreModel } from "./StoreModel";
import { QueryReturn } from "./datatypes";
import { User } from "firebase/auth";
import { FirebaseFirestoreTypes } from "@react-native-firebase/firestore";
export declare class UserModel extends StoreModel implements AuthInterface {
    private _auth;
    constructor(auth: FirebaseAuthTypes.Module, firestoreDB: FirebaseFirestoreTypes.Module, table?: string);
    registerWithEmailAndPassword({ email, password, userData }: {
        email: string;
        password: string;
        userData?: object;
    }): Promise<QueryReturn>;
    login({ email, password, verifyEmail }: {
        email: string;
        password: string;
        verifyEmail?: boolean;
    }): Promise<QueryReturn>;
    logout(): Promise<QueryReturn>;
    deleteAccount(user: User): Promise<QueryReturn>;
}
