export const generateRandomString = (length) => {
    if (length > 60) {
        throw new Error(`Maximum generatable character is 60, ${length} was required`);
    }
    var result = '';
    var characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
};
export const getUrlParams = () => {
    const urlParams = new URLSearchParams(window.location.search);
    return Object.fromEntries(urlParams);
};
export const camelToTitleCase = (key) => {
    const topic = key[0].toUpperCase() + key.slice(1);
    let result = '';
    let i = 0;
    while (i < topic.length) {
        if (i === 0) {
            result += topic.charAt(i);
        }
        else {
            if (topic.charAt(i) === topic.charAt(i).toUpperCase()) {
                result += ` ${topic.charAt(i)}`;
            }
            else {
                result += topic.charAt(i);
            }
        }
        i++;
    }
    return result;
};
export const getCurrentLocation = () => {
    const currentPath = window.location.pathname;
    const pathArr = currentPath.split('/');
    return pathArr[1];
};
export function convertUnicode(input) {
    return input.replace(/\\+u([0-9a-fA-F]{4})/g, (a, b) => String.fromCharCode(parseInt(b, 16)));
}
export const moneyFormatter = (x, shorten = true, decimailPlaces) => {
    if (x === undefined) {
        return "";
    }
    const base = 1000000;
    const num = parseInt(x);
    if (num < base || !shorten) {
        return num.toFixed(decimailPlaces).replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    }
    else {
        let val = '';
        if (num < (base * 1000)) {
            val = (num / base).toFixed(decimailPlaces) + "M";
        }
        else {
            val = (num / (base * 1000)).toFixed(decimailPlaces) + "B";
        }
        return val;
    }
};
//# sourceMappingURL=helpers.js.map